'use strict';

angular.module('datasid', ['ngResource', 'ui.router', 'datasid.install', 'datasid.doc', 'datasid.attendance', 'datasid.attendance.search']).
    config(function($stateProvider, $httpProvider) {
        $stateProvider.
            state('index', {
                url: '',
                templateUrl: 'partials/index.html',
            });
    }).

    directive('mcActiveClass', function($animate) {
        return function (scope, element, attrs) {
            scope.$watch(attrs.mcActiveClass, function (value) {
                $animate[toBoolean(value) ? 'addClass' : 'removeClass'](element, 'active');
            });
        }
    }).

    directive('mcCollapsedClass', function($animate) {
        return function (scope, element, attrs) {
            scope.$watch(attrs.mcCollapsedClass, function (value) {
                $animate[toBoolean(value) ? 'addClass' : 'removeClass'](element, 'collapsed');
            });
        }
    }).

    directive('mcChart', function() {
        return function (scope, element, attrs) {
            scope[attrs.mcChart].render(element);
        }
    }).

    controller('MainCtrl', function ($scope, $rootScope, $state) {
        $scope.bigButtons = {
            collapsed: false,
            rowClass: "",
            order: "",
            current: null,
            items: [
                {
                    title: "Acompanhamento",
                    icon: "icon-charts",
                    color: "dark",
                    link: "#/attendance",
                    section: "attendance",
                    active: false
                },
                {
                    title: "Instalação",
                    icon: "icon-install",
                    color: "medium",
                    link: "#/install",
                    section: "install",
                    active: false
                },
                {
                    title: "Documentação",
                    icon: "icon-doc",
                    color: "light",
                    link: "#/doc",
                    section: "doc",
                    active: false
                },
            ],
        }

        $scope.$on("$stateChangeSuccess", function(event, toState, toParams, fromState, fromParams) {
            if (typeof $state.current === "undefined")
                return;

            if (!("section" in $state.current)) {
                $scope.bigButtons.collapsed = false;
                $scope.bigButtons.order = "";
            }
            else {
                $scope.bigButtons.collapsed = true;
                $scope.bigButtons.order = "-active";

                angular.forEach($scope.bigButtons.items, function (item) {
                    item.active = (item.section === $state.current.section);
                    if (item.active) {
                        $scope.bigButtons.current = item;
                        $scope.bigButtons.rowClass = item.color;
                    }
                });
            }
        })
    });